unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Einlesen;
    procedure Ausgeben;
    procedure StringZuArray;
    procedure ArrayZuString;
    procedure Encode;
    procedure Decode;
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;
  eingabe,key,keylang,ausgabe:string;
  eingabezahl,keyzahl,ausgabezahl:array of integer;
  eingabelaenge,keylaenge,i,j:integer;
  zeichen:char;
  rechnen:boolean;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  //Verschluesseln
  label6.Caption:='';
  label7.Caption:='';
  edit3.Text:='';
  rechnen:=true;
  Einlesen;
  if (eingabe = '') or (key = '') then label6.Caption:='Eingabe unvollständig!' else
    begin
    StringZuArray;
    if rechnen then
        begin
        Encode;
        ArrayZuString;
        Ausgeben
        end;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  //Entschluesseln
  label6.Caption:='';
  label7.Caption:='';
  edit3.Text:='';
  rechnen:=true;
  Einlesen;
  if (eingabe = '') or (key = '') then label6.Caption:='Eingabe unvollständig!' else
    begin
      StringZuArray;
      if rechnen then
        begin
          Decode;
          ArrayZuString;
          Ausgeben
        end;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  //Programm beenden
  close
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  edit1.Text:='';
  edit2.Text:='';
  edit3.Text:='';
  label6.Caption:='';
  label7.Caption:=''
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  edit1.Text:=edit3.Text;
  edit3.Text:='';
end;

procedure TForm1.Einlesen;
begin
  //Einlesen
  eingabe:=edit1.Text;
  key:=edit2.Text;
end;

procedure TForm1.Ausgeben;
begin
  //Ausgabe
  edit3.Text:=ausgabe;
end;

procedure TForm1.StringZuArray;
begin
  //String auf Array abbilden
  eingabelaenge:=length(eingabe);
  keylaenge:=length(key);
  SetLength(eingabezahl,eingabelaenge);
  SetLength(keylang,eingabelaenge);
  keylang:=key;
  //Schlüssellänge anpassen
  if keylaenge < eingabelaenge then
      begin
        j:=(eingabelaenge div keylaenge) +1;
        for i:=0 to j do
            keylang:=keylang+key
      end;
  SetLength(keyzahl,length(keylang));
  //Eingabestring auf Array abbilden
  for i:=1 to eingabelaenge do
      begin
        zeichen:=eingabe[i];
        case zeichen of
        'a': eingabezahl[i]:=1;
        'b': eingabezahl[i]:=2;
        'c': eingabezahl[i]:=3;
        'd': eingabezahl[i]:=4;
        'e': eingabezahl[i]:=5;
        'f': eingabezahl[i]:=6;
        'g': eingabezahl[i]:=7;
        'h': eingabezahl[i]:=8;
        'i': eingabezahl[i]:=9;
        'j': eingabezahl[i]:=10;
        'k': eingabezahl[i]:=11;
        'l': eingabezahl[i]:=12;
        'm': eingabezahl[i]:=13;
        'n': eingabezahl[i]:=14;
        'o': eingabezahl[i]:=15;
        'p': eingabezahl[i]:=16;
        'q': eingabezahl[i]:=17;
        'r': eingabezahl[i]:=18;
        's': eingabezahl[i]:=19;
        't': eingabezahl[i]:=20;
        'u': eingabezahl[i]:=21;
        'v': eingabezahl[i]:=22;
        'w': eingabezahl[i]:=23;
        'x': eingabezahl[i]:=24;
        'y': eingabezahl[i]:=25;
        'z': eingabezahl[i]:=26;
        'A': eingabezahl[i]:=27;
        'B': eingabezahl[i]:=28;
        'C': eingabezahl[i]:=29;
        'D': eingabezahl[i]:=30;
        'E': eingabezahl[i]:=31;
        'F': eingabezahl[i]:=32;
        'G': eingabezahl[i]:=33;
        'H': eingabezahl[i]:=34;
        'I': eingabezahl[i]:=35;
        'J': eingabezahl[i]:=36;
        'K': eingabezahl[i]:=37;
        'L': eingabezahl[i]:=38;
        'M': eingabezahl[i]:=39;
        'N': eingabezahl[i]:=40;
        'O': eingabezahl[i]:=41;
        'P': eingabezahl[i]:=42;
        'Q': eingabezahl[i]:=43;
        'R': eingabezahl[i]:=44;
        'S': eingabezahl[i]:=45;
        'T': eingabezahl[i]:=46;
        'U': eingabezahl[i]:=47;
        'V': eingabezahl[i]:=48;
        'W': eingabezahl[i]:=49;
        'X': eingabezahl[i]:=50;
        'Y': eingabezahl[i]:=51;
        'Z': eingabezahl[i]:=52;
        '1': eingabezahl[i]:=53;
        '2': eingabezahl[i]:=54;
        '3': eingabezahl[i]:=55;
        '4': eingabezahl[i]:=56;
        '5': eingabezahl[i]:=57;
        '6': eingabezahl[i]:=58;
        '7': eingabezahl[i]:=59;
        '8': eingabezahl[i]:=60;
        '9': eingabezahl[i]:=61;
        '0': eingabezahl[i]:=62;
        '.': eingabezahl[i]:=63;
        ',': eingabezahl[i]:=64;
        ';': eingabezahl[i]:=65;
        ':': eingabezahl[i]:=66;
        '!': eingabezahl[i]:=67;
        '?': eingabezahl[i]:=68;
        '-': eingabezahl[i]:=69;
        '_': eingabezahl[i]:=70;
        '#': eingabezahl[i]:=71;
        '^': eingabezahl[i]:=72;
        ' ': eingabezahl[i]:=73;
        else
            begin
              rechnen:=false;
              label6.Caption:='Klar-/Schlüsseltext: nicht unterstütztes Zeichen!'
            end;
        end;
      end;
  //verlängerten Schlüsselstring auf Array abbilden
  for i:=1 to length(keylang) do
      begin
        zeichen:=keylang[i];
        case zeichen of
        'a': keyzahl[i]:=1;
        'b': keyzahl[i]:=2;
        'c': keyzahl[i]:=3;
        'd': keyzahl[i]:=4;
        'e': keyzahl[i]:=5;
        'f': keyzahl[i]:=6;
        'g': keyzahl[i]:=7;
        'h': keyzahl[i]:=8;
        'i': keyzahl[i]:=9;
        'j': keyzahl[i]:=10;
        'k': keyzahl[i]:=11;
        'l': keyzahl[i]:=12;
        'm': keyzahl[i]:=13;
        'n': keyzahl[i]:=14;
        'o': keyzahl[i]:=15;
        'p': keyzahl[i]:=16;
        'q': keyzahl[i]:=17;
        'r': keyzahl[i]:=18;
        's': keyzahl[i]:=19;
        't': keyzahl[i]:=20;
        'u': keyzahl[i]:=21;
        'v': keyzahl[i]:=22;
        'w': keyzahl[i]:=23;
        'x': keyzahl[i]:=24;
        'y': keyzahl[i]:=25;
        'z': keyzahl[i]:=26;
        'A': keyzahl[i]:=27;
        'B': keyzahl[i]:=28;
        'C': keyzahl[i]:=29;
        'D': keyzahl[i]:=30;
        'E': keyzahl[i]:=31;
        'F': keyzahl[i]:=32;
        'G': keyzahl[i]:=33;
        'H': keyzahl[i]:=34;
        'I': keyzahl[i]:=35;
        'J': keyzahl[i]:=36;
        'K': keyzahl[i]:=37;
        'L': keyzahl[i]:=38;
        'M': keyzahl[i]:=39;
        'N': keyzahl[i]:=40;
        'O': keyzahl[i]:=41;
        'P': keyzahl[i]:=42;
        'Q': keyzahl[i]:=43;
        'R': keyzahl[i]:=44;
        'S': keyzahl[i]:=45;
        'T': keyzahl[i]:=46;
        'U': keyzahl[i]:=47;
        'V': keyzahl[i]:=48;
        'W': keyzahl[i]:=49;
        'X': keyzahl[i]:=50;
        'Y': keyzahl[i]:=51;
        'Z': keyzahl[i]:=52;
        '1': keyzahl[i]:=53;
        '2': keyzahl[i]:=54;
        '3': keyzahl[i]:=55;
        '4': keyzahl[i]:=56;
        '5': keyzahl[i]:=57;
        '6': keyzahl[i]:=58;
        '7': keyzahl[i]:=59;
        '8': keyzahl[i]:=60;
        '9': keyzahl[i]:=61;
        '0': keyzahl[i]:=62;
        '.': keyzahl[i]:=63;
        ',': keyzahl[i]:=64;
        ';': keyzahl[i]:=65;
        ':': keyzahl[i]:=66;
        '!': keyzahl[i]:=67;
        '?': keyzahl[i]:=68;
        '-': keyzahl[i]:=69;
        '_': keyzahl[i]:=70;
        '#': keyzahl[i]:=71;
        '^': keyzahl[i]:=72;
        ' ': keyzahl[i]:=73;
        else
            begin
            rechnen:=false;
            label7.Caption:='Schlüssel: nicht unterstütztes Zeichen!'
            end;
        end;
      end;
end;

procedure TForm1.ArrayZuString;
//Ausgabearray auf Ausgabestring abbilden
begin
  SetLength(ausgabe,length(ausgabezahl));
  for i:=1 to length(ausgabezahl) do
      begin
        j:=ausgabezahl[i];
        case j of
        1: ausgabe[i]:='a';
        2: ausgabe[i]:='b';
        3: ausgabe[i]:='c';
        4: ausgabe[i]:='d';
        5: ausgabe[i]:='e';
        6: ausgabe[i]:='f';
        7: ausgabe[i]:='g';
        8: ausgabe[i]:='h';
        9: ausgabe[i]:='i';
        10: ausgabe[i]:='j';
        11: ausgabe[i]:='k';
        12: ausgabe[i]:='l';
        13: ausgabe[i]:='m';
        14: ausgabe[i]:='n';
        15: ausgabe[i]:='o';
        16: ausgabe[i]:='p';
        17: ausgabe[i]:='q';
        18: ausgabe[i]:='r';
        19: ausgabe[i]:='s';
        20: ausgabe[i]:='t';
        21: ausgabe[i]:='u';
        22: ausgabe[i]:='v';
        23: ausgabe[i]:='w';
        24: ausgabe[i]:='x';
        25: ausgabe[i]:='y';
        26: ausgabe[i]:='z';
        27: ausgabe[i]:='A';
        28: ausgabe[i]:='B';
        29: ausgabe[i]:='C';
        30: ausgabe[i]:='D';
        31: ausgabe[i]:='E';
        32: ausgabe[i]:='F';
        33: ausgabe[i]:='G';
        34: ausgabe[i]:='H';
        35: ausgabe[i]:='I';
        36: ausgabe[i]:='J';
        37: ausgabe[i]:='K';
        38: ausgabe[i]:='L';
        39: ausgabe[i]:='M';
        40: ausgabe[i]:='N';
        41: ausgabe[i]:='O';
        42: ausgabe[i]:='P';
        43: ausgabe[i]:='Q';
        44: ausgabe[i]:='R';
        45: ausgabe[i]:='S';
        46: ausgabe[i]:='T';
        47: ausgabe[i]:='U';
        48: ausgabe[i]:='V';
        49: ausgabe[i]:='W';
        50: ausgabe[i]:='X';
        51: ausgabe[i]:='Y';
        52: ausgabe[i]:='Z';
        53: ausgabe[i]:='1';
        54: ausgabe[i]:='2';
        55: ausgabe[i]:='3';
        56: ausgabe[i]:='4';
        57: ausgabe[i]:='5';
        58: ausgabe[i]:='6';
        59: ausgabe[i]:='7';
        60: ausgabe[i]:='8';
        61: ausgabe[i]:='9';
        62: ausgabe[i]:='0';
        63: ausgabe[i]:='.';
        64: ausgabe[i]:=',';
        65: ausgabe[i]:=';';
        66: ausgabe[i]:=':';
        67: ausgabe[i]:='!';
        68: ausgabe[i]:='?';
        69: ausgabe[i]:='-';
        70: ausgabe[i]:='_';
        71: ausgabe[i]:='#';
        72: ausgabe[i]:='^';
        73: ausgabe[i]:=' ';
        end;
      end;
end;

procedure TForm1.Encode;
//Codieren
begin
   SetLength(ausgabezahl,eingabelaenge);
   for i:=0 to eingabelaenge do
       begin
         ausgabezahl[i]:=eingabezahl[i]+keyzahl[i];
         if ausgabezahl[i] > 73 then ausgabezahl[i]:=ausgabezahl[i]-73
       end;
end;

procedure TForm1.Decode;
//Decodieren
begin
  SetLength(ausgabezahl,eingabelaenge);
  for i:=0 to eingabelaenge do
      begin
        ausgabezahl[i]:=eingabezahl[i]-keyzahl[i];
        if ausgabezahl[i] < 1 then ausgabezahl[i]:=ausgabezahl[i]+73
      end;
end;

end.

